
#ifndef _ConceptMap_h_
#define _ConceptMap_h_

#include "Concept.h"
#include <map>

typedef map<String,Concept*,less<String> >  ConceptMap;
void printGlobalConcepts();

Concept* findGlobalConcept(const String& name);
Concept* insertGlobalConcept(Concept* concept);

template <class ConceptType>
ConceptType* addGlobalConcept(const String& name,ConceptType* dummy)
{
  // there are cases where I can skip the new (when the concept is already exists)
  ConceptType* concept = new ConceptType(name);
  concept = insertGlobalConcept(concept);
  return concept;
}
#endif
